---
name: Bug report - Installation
about: Create a report about installation issues
title: ''
labels: ''
assignees: ''

---

Before you raise a bug, please make sure you have fully read the README, especially if your bug relates to configuring the database.

Issues will be closed if the answer is in the README and no obvious attempts have been made to follow it.

Support will only be given for users running the latest pull of code from GitHub. Not a tagged release, not a pre-installed app, not a ZIP you got from a mate.

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
What have you installed, what are you running when you get the error...

Steps to reproduce the behaviour:
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

**Logs**
Include the last five lines of the Apache log file from directly after the problem happened.

**Expected behaviour**
A clear and concise description of what you expected to happen.

**What have you done to help fix the issue yourself?**
What have you tried, what research have you done, what changes have you made.

**Screenshots**
If applicable, add screenshots to help explain your problem.

**System (please complete the following information):**
 - OS: [e.g. Windows, Ubuntu]
 - Database and Version [e.g. MySQL, MariaDB, 10.5.12-MariaDB]
 - PHP Version [e.g. 7.4.25]
- Installed PHP modules

**Additional context**
Add any other context about the problem here.
