## ascii-art-web-dockerize

### Objectives

You must follow the same [principles](../README.md) as the first subject.

- For this project you must create at least :

  - one Dockerfile
  - one image
  - one container

- You must apply [metadata](https://docs.docker.com/config/labels-custom-metadata/) to Docker objects.

- You have to take caution of unused object (often referred to as "garbage collection").

### Instructions

- The web server must be created in **Go**.
- The code must respect the [good practices](../../good-practices/README.md).
- You must use Docker.
- The project must have a **Dockerfile**.
- Your Dockerfile must respect the [Dockerfile good practices](https://docs.docker.com/develop/develop-images/dockerfile_best-practices/).

### Allowed packages

- Only the [standard go](https://golang.org/pkg/) packages are allowed.

### Usage

- You can see all about Docker on [docker docs](https://docs.docker.com/).

This project will help you learn about :

- Client utilities.
- The basics of web :
  - Server
  - HTML
  - HTTP
- Ways to receive data.
- Ways to output data.
- Learning what is [docker](https://docs.docker.com).
- Using and [setting up Docker](https://docs.docker.com/get-started/) :
  - Services and dependencies.
  - Containerizing an application.
  - Compatibility/Dependency.
  - Creating images.
