# Send Eth Transaction

You will create your first transaction on Ethereum using one of its testnets. We recommend Goerli as it is the most commonly used testnet, but you can use any other testnet.

### Instructions

- Create manually a wallet on any **Ethereum testnet**

- Get testnet Ether on a faucet (You might have to try several)

- Send a transaction of 0.000000000000001337 Ethers to the address '0x7A7a4EdC679bC4E29F74E32E9eEDd256cd435FBb'

- Create a js file and store the hash of your transaction in a variable `txid`

### Usage

```js
exports.txid =
  "0xf02c4a1487aa2e45fc2c77cb5a28713a1474d86d5f4292b264875ccc5da82b67";
```

### Notions

- A full list of Ethereum compatible wallets [ethereum wallets](https://ethereum.org/en/wallets/find-wallet/)
- The commonly used wallet for development [MetaMask](https://metamask.io/)
- Find a [goerli faucet](https://letmegooglethat.com/?q=goerli+faucet)
