## math-skills

### Objectives

The purpose of this project is for you to calculate the following:

- Average
- Median
- Variance
- Standard Deviation

### Instructions

Your program must be able to read from a file and print the result of each statistic mentioned above. In other words, your program must be able to read the data present in the path passed as argument. The data in the file will be presented as the following example:

```console
189
113
121
114
145
110
...
```

This data represents a [statistical population](https://en.wikipedia.org/wiki/Statistical_population): each line contains one value.

To run your program a command similar to this one will be used if your project is made in Go:

```sh
$> go run your-program.go data.txt
```

After reading the file, your program must execute each of the calculations asked above and print the results in the following manner (the following numbers are only examples):

```console
Average: 35
Median: 4
Variance: 5
Standard Deviation: 65
```

Please note that the values are rounded integers.

### Testing

Your program will be tested by an auditor who will run a program provided by us. This program creates a random data set of numbers and prints the result. The auditor job is to compare how your program performed.

You can choose the language in which you want to build your program.

This project will help you learn about:

- Statistics and Mathematics
  - [Average](https://en.wikipedia.org/wiki/Average)
  - [Median](https://en.wikipedia.org/wiki/Median)
  - [Variance](https://en.wikipedia.org/wiki/Variance)
  - [Standard Deviation](https://en.wikipedia.org/wiki/Standard_deviation)
