# Stock Market

### Exercise

Develop an app that will simulate a `real-time` stock market. You may use [Yahoo](https://algotrading101.com/learn/yahoo-finance-api-guide/#:~:text=Why%20should%20I%20use%20the%20Yahoo%20Finance%20API%3F,-Free&text=One%20good%20reason%20is%20because%20it%20can%20be%20completely%20free.) API for data retrieval.

For any new user, provide them with `1,000,000$` fake dollars, so that they can do operations within your app. These operations include:

- Log in/out
- Buy/hold stocks
- See historical charts of stock prices
- Retrieve data about a particular stock for the last year or since the company went public
- Updating data about a stock (Updating data atleast 5 times in a second is considered real-time)

Make sure to manage states via any of the following patterns:

- BLoC
- Provider
- MVC

### Todo list

- Route for login/signup page
- Route with all the purchased stocks
- Route to display historical data of the chosen stock
- All the data must be fetched in real-time
- Choose 20 stocks to monitor

### Objective

- Fetching data in real-time
- Visualizing custom widgets in real-time
- Making authentication and authorization services
- Use of patterns

<center>

<img src="./resources/stockMarket.01.jpg?raw=true" style = "width: 210px !important; height: 420px !important;"/>

<img src="./resources/stockMarket.02.jpg?raw=true" style = "width: 210px !important; height: 420px !important;"/>
</center>
